#!/usr/bin/env python
#
# $Id: vidthumb.py,v 1.13 2005/04/22 15:25:09 stephen Exp $

"""Generate thumbnails for video files.  This must be called as
      vidthumb.py source_file destination_thumbnail maximum_size
where maximum_size is the maximum width and height.

This uses mplayer to grab a single frame as a .png file, then gdk-pixbuf (via
pygtk 1.99.x) to generate a thumbnail of that frame.  A film strip effect is
added to mark the thumbnail as from a video file.

To use this in ROX-Filer, get a recent version then run VideoThumbnail and
click on "Install handlers".  Generating a video thumbnail takes a lot longer
than a simple image file, but ROX-Filer remains responsive while it is
being processed.
"""

import os, sys
import md5
import rox, rox.mime
import pango

import thumb

# Defaults
import options

outname=None
rsize=options.tsize.int_value

class VidThumb(thumb.Thumbnailler):
    """Generate thumbnail for pdf files"""
    def __init__(self, debug=False):
        """Initialize image thumbnailler"""
        thumb.Thumbnailler.__init__(self, 'VidThumb', 'vidthumb',
                                    True, debug)
    def get_image(self, inname, rsize):
        """Convert image to PNG"""
    	(fnamenoext, ext) = os.path.splitext(os.path.basename(inname))
	frfname = fnamenoext + '.png'	
	
	cmd=eval(comando)
	
	os.system(cmd)
	try:
		os.stat(frfname)
	except:
		self.report_exception()
		sys.exit(2)
	
        # Now we load the raw image in
        gtk=rox.g

        return gtk.gdk.pixbuf_new_from_file(frfname)

    def process_image(self, img, rsize):
	return img


                
# Process command line args.  Although the filer always passes three args,
# let the last two default to something sensible to allow use outside
# the filer.
def main(argv):
    """Process command line args.  Although the filer always passes three args,
    let the last two default to something sensible to allow use outside
    the filer."""
    global rsize, comando
    
#    print argv
    inname=argv[0]
    try:
        outname=argv[1]
    except:
        pass
    try:
        rsize=int(argv[2])
    except:
        pass
    try:
        comando=argv[3]
    except:
        pass
    
    if not os.path.isabs(inname):
        inname=os.path.abspath(inname)

    # Out file name is based on MD5 hash of the URI
    if not outname:
        uri='file://'+inname
        tmp=md5.new(uri).digest()
        leaf=''
        for c in tmp:
            leaf+='%02x' % ord(c)
        outname=os.path.join(os.environ['HOME'], '.thumbnails', 'normal',
                         leaf+'.png')
    elif not os.path.isabs(outname):
        outname=os.path.abspath(outname)
    #print inname, outname, rsize

    thumb=VidThumb()
    thumb.run(inname, outname, rsize)

def configure():
    """Configure the app"""
    options.edit_options()
    rox.mainloop()

if __name__=='__main__':
    main(sys.argv[1:])
